\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("c-curve-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

PartN(k) = 1/3*(2^k + vector_modulo([-1,1],k));
PartSegments(k) = 1/3*(2^k + vector_modulo([2,-2],k));

GpartTotal(k) =
{
  11/42 * (2*sqrt2)^k
  + 1/6 * vector_modulo([1, -7],k) * (sqrt2)^k
  + 3/14*vector_modulo([-2, 3*sqrt2],k);
}

\\-----------------------------------------------------------------------------

Gpart_ref(k) = GpartTotal(k) / PartSegments(k);

Gpart(k) =
{
  (
   11/42 * (2*sqrt2)^k
   + 1/6 * vector_modulo([1, -7],k) * (sqrt2)^k
   + 3/14*vector_modulo([-2, 3*sqrt2],k)
  ) / ( 1/3*(2^k + vector_modulo([2,-2],k)) );
}
check_exact(vector(100,k,k++; Gpart(k)), vector(100,k,k++; Gpart_ref(k)))

Gpart(k) =
{
  (
   11/14 * (2*sqrt2)^k
   + 1/2 * vector_modulo([1, -7],k) * (sqrt2)^k
   + 9/14 * vector_modulo([-2, 3*sqrt2],k)
  ) / (2^k + vector_modulo([2,-2],k) );
}
check_exact(vector(100,k,k++; Gpart(k)), vector(100,k,k++; Gpart_ref(k)))

Gpart(k) =
{
  11/14 * sqrt2^k
  + (
   - 11/14 * vector_modulo([2,-2],k) * sqrt2^k
   + 1/2 * vector_modulo([1, -7],k) * sqrt2^k
   + 9/14 * vector_modulo([-2, 3*sqrt2],k)
  ) / (2^k + vector_modulo([2,-2],k) );
}
check_exact(vector(100,k,k++; Gpart(k)), vector(100,k,k++; Gpart_ref(k)))

Gpart(k) =
{
  11/14 * sqrt2^k
  + 1/14 * (
   - vector_modulo([15, 27],k) * sqrt2^k
   + vector_modulo([-18, 27*sqrt2],k)
  ) / (2^k + vector_modulo([2,-2],k) );
}
check_exact(vector(100,k,k++; Gpart(k)), vector(100,k,k++; Gpart_ref(k)))
