\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("../tools/memoize.gp");
b = 1 + I;
sqrt2 = quadgen(8);
vector_modulo(v,i) = v[(i% #v)+1];

nearly_equal(x,y) = abs(x-y) <= max(abs(x),max(abs(y),1))*1e-10;

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count));
}

R(k) = if(k%2,10,7)*2^floor(k/2) - 2*k - 6;
RS(j) = 2^j;
RZ(j) = 2*(2^j-1);

c_curve_segments(k) = {
  my(v = [1/2], end=1);
  for(i=1,k,
      v = concat(v, apply((z)->end+z*I, v));
      end *= b);
  v;
}

xy_rotate_minus45(v) = [ v[1]+v[2], -v[1]+v[2] ]/sqrt2;
xy_rotate_minus45_times(v,n) = for(i=1,n%8, v=xy_rotate_minus45(v)); v;

b_real_sign_vector = [1,1,0,-1, -1,-1,0,1];
b_real_sign(k) = b_real_sign_vector[(k%8)+1];
b_real(k) = b_real_sign(k) * 2^floor(k/2);
b_imag_sign_vector = [0,1,1,1, 0,-1,-1,-1];
b_imag_sign(k) = b_imag_sign_vector[(k%8)+1];
b_imag(k) = b_imag_sign(k) * 2^floor(k/2);
check_exact(vector(64,k,my(k=k-1); real(b^k)), \
            vector(64,k,my(k=k-1);  b_real(k)));
check_exact(vector(64,k,my(k=k-1); imag(b^k)), \
            vector(64,k,my(k=k-1);  b_imag(k)));

G(k) = 1/2*(sqrt2^k - 1/sqrt2^k);
Ix(k) = 1/8*(4^k - (2*k-1)*2^k - 2);
Iy(k) = Ix(k+1) - Ix(k);
Iz(k) = Ix(k) + Iy(k);

print("Ix ",vector(16,k,my(k=k-1); Ix(k) ));
print("Iz ",vector(16,k,my(k=k-1); Iz(k) ));


\\-----------------------------------------------------------------------------

t_k_minus_1(k) = G(k-1)/sqrt2 + 1/2*sqrt2^(k-1)/sqrt2;
mass(k) = 2^k;
Iz_rec(k) = if(k==0,0, \
    1/2 * (  2*Iz_rec(k-1) + 2*t_k_minus_1(k)^2) );
print("Iz rec ",vector(10,k,my(k=k-1); Iz_rec(k) ));
print("Iz sca ",vector(10,k,my(k=k-1); Iz(k)/2^k ));
print("\n");

print(vector(20,k,my(k=k-1); 8*(Ix(k) + 1/4)/2^k ))

\\ A183155 ,1,1,3,9,23,53
\\ A244331 ,0,1,3,9,23,53

quit;

print(vector(16,k,my(k=k-1); 1/4*(2*4^k - (2*k + 1)*2^k - 1)));


print(vector(16,k,my(k=k-1); Iz(k)/2^k ));
mass(k) = 1;
print(vector(16,k,my(k=k-1); Iz(k) ));
print(vector(16,k,my(k=k-1); Iz(k) + 1/8*1/2^k) );
